#define _WIN32_WINNT 0x0500
#include "util.h"
#include "fontsize.h"
#include "dlgsize.h"
#include <shlwapi.h>
#pragma intrinsic(memset)

FUNC(void) InitDLL() {}

#pragma bss_seg("shared")
HINSTANCE ghInstance;
HHOOK ghhook;
ATOM gAtom;
unsigned gNumProcess;
#pragma bss_seg()
#pragma comment(linker, "/section:shared,RWS")

void GetBaseUnit(HWND hDlg,SIZE&sz) {
 RECT rc;
 SetRect(&rc,0,0,4,8);
 MapDialogRect(hDlg,&rc);
 sz.cx=rc.right;
 sz.cy=rc.bottom;
}

struct Dialog2{
 enum{
  fromCreateDialog=23748419<<4,	// Bit 0: Param given
  fromCreateDialogParam,	// Bit 1: Indirect given
  fromCreateDialogIndirect,	// Bit 2: Box given
  fromCreateDialogIndirectParam,
  fromDialogBox,
  fromDialogBoxParam,
  fromDialogBoxIndirect,
  fromDialogBoxIndirectParam,
  fromMessageBox,
  fromMessageBoxEx,
 };
 DWORD cookie;
 LPARAM lp;
 const DLGTEMPLATE*t;
 const TCHAR*resName;
 HINSTANCE resInst;
};

class DlgHook{
public:
 WNDPROC prevwndproc;
 RECT wr0;	// Fenstergre beim Erstellen
 SIZE fs0,	// Erste Fontgre
      cs0;	// Erste Client-Gre
 HFONT font,	// Aktueller Font
	f0;	// Erster Font (fr ^0)
 HMENU hmFont;	// Schriftauswahl-Submen (8 Menpunkte 0xF200..0xF270)
 static LRESULT CALLBACK MyDialogProc(HWND,UINT,WPARAM,LPARAM);
 bool onSetFont(HWND,HFONT,DWORD);
 void checkFontMenu();
 void chooseFont(HWND);
 static UINT_PTR CALLBACK CFHookProc(HWND,UINT,WPARAM,LPARAM);
};

class ChildHook{
public:
// WNDPROC prevwndproc;
 RECT wr0;	// Fensterposition und -gre beim Erstellen
// SIZE fs_cr;	// Schriftgre des Elterndialogs beim Erstellen
// static LRESULT CALLBACK MyChildProc(HWND,UINT,WPARAM,LPARAM);
};

LRESULT CALLBACK DlgHook::MyDialogProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam) {
 DlgHook*dh=(DlgHook*)GetProp(hWnd,MAKEINTATOM(gAtom));
// if (msg==WM_INITDIALOG) {
//  HFONT f=GetWindowFont(hWnd);
//  if (!dh->font && f) dh->font=f;
// }
 LRESULT ret;
// Von wegen, der Dialog bekommt kein WM_SETFONT!
// Tatschlich bekommt dieser eins beim Erstellen.
// Mglicherweise nur wenn DS_SETFONT gesetzt, d.h. FONT definiert in Ressource
 if (msg==WM_SETFONT) ret=(dh->onSetFont(hWnd,(HFONT)wParam,(UINT)lParam),0);
 else ret=CallWindowProc(dh->prevwndproc,hWnd,msg,wParam,lParam);
 if (msg==WM_INITDIALOG) {
  dh->hmFont=LoadMenu(ghInstance,MAKEINTRESOURCE(1));
  HMENU sysm=GetSystemMenu(hWnd,FALSE);
  TCHAR s[32];
  GetMenuString(dh->hmFont,0,s,elemof(s),MF_BYPOSITION);
  InsertMenu(sysm,GetMenuItemCount(sysm)-2,MF_BYPOSITION|MF_POPUP,(INT_PTR)GetSubMenu(dh->hmFont,0),s);
 }
 if (msg==WM_SYSCOMMAND) switch (wParam&0xFFF0) {
  case 0xF200: dh->chooseFont(hWnd); break;
  case 0xF210: dh->onSetFont(hWnd,0,(BYTE)+1<<8); break;
  case 0xF220: dh->onSetFont(hWnd,0,(BYTE)-1<<8); break;
  case 0xF230: dh->onSetFont(hWnd,0,8); break;	// Revert (TODO)
  case 0xF240:
  case 0xF250:
  case 0xF260:
  case 0xF270: dh->onSetFont(hWnd,0,3<<(16+(wParam>>4&3)*2)); break;
 }	// Da das vom Systemmen kommt, linke obere Ecke des Dialogs fixiert lassen
 if (msg==WM_MOUSEWHEEL && GET_KEYSTATE_WPARAM(wParam)&MK_CONTROL && dh) {
  dh->onSetFont(hWnd,0,BYTE(GET_WHEEL_DELTA_WPARAM(wParam)/WHEEL_DELTA)<<8|SFF_FIXONSIZE_MOUSE);
 }
 if (msg==WM_NCDESTROY) {
  DestroyMenu(dh->hmFont);
  LocalFree(dh);
 }
 return ret;
}

#if 0
LRESULT CALLBACK ChildHook::MyChildProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam) {
 ChildHook*ch=(ChildHook*)GetProp(hWnd,gAtom);
 LRESULT ret=0;
 switch (msg) {
  case WM_SETFONT: {	// Erst jetzt ist der Font der Dialogboxvorlage bekannt!
   HWND hDlg=hWnd;
   do hDlg=GetParent(hDlg); while (GetWindowStyle(hDlg)&WS_CHILD);
   DlgHook*dh=(DlgHook*)GetProp(hDlg,gAtom);
   if (!dh) break;	// Oh, das Fenster hat keine Dialogbox als Parent
   if (dh->font) break;	// Der Font ist bereits bekannt, nichts tun
// Erste Methode
   GetFontSize(hDlg,(HFONT)wParam,dh->baseunit[0]);
   if (dh->baseunit[0].cx&&dh->baseunit[0].cy) dh->font=(HFONT)wParam;
// Zweite Methode
   GetBaseUnit(hDlg,dh->baseunit[1]);
  }break;
 }
 ret=CallWindowProc(ch->prevwndproc,hWnd,msg,wParam,lParam);
 if (msg==WM_NCDESTROY) LocalFree(ch);
 return ret;
}
#endif

LRESULT CALLBACK CBTProc(int nCode,WPARAM wParam, LPARAM lParam) {
 switch (nCode) {
  case HCBT_CREATEWND: {
   LRESULT ret=CallNextHookEx(ghhook,nCode,wParam,lParam);
   HWND w=(HWND)wParam;
   CBT_CREATEWND&cw=*(CBT_CREATEWND*)lParam;
   CREATESTRUCT&cs=*cw.lpcs;
   if (!((cs.style^WS_CAPTION)&(WS_CHILD|WS_CAPTION))) {
    DBG(("CreateNonchild(class=%X,text=%s)",cs.lpszClass,cs.lpszName));
    if (cs.lpszClass==MAKEINTATOM(0x8002)) {
     DlgHook*dh=(DlgHook*)LocalAlloc(LPTR,sizeof(DlgHook));
     SetProp(w,MAKEINTATOM(gAtom),dh);
     dh->prevwndproc=SubclassWindow(w,DlgHook::MyDialogProc);
     SetRect(&dh->wr0,cs.x,cs.y,cs.cx,cs.cy);
    }
   }else if (cs.style&WS_CHILD) {
    DBG(("CreateChild(class=%X,text=%s)",cs.lpszClass,cs.lpszName));
    ChildHook*ch=(ChildHook*)LocalAlloc(LPTR,sizeof(ChildHook));
    SetProp(w,MAKEINTATOM(gAtom),ch);
//    ch->prevwndproc=SubclassWindow(w,ChildHook::MyChildProc);
    SetRect(&ch->wr0,cs.x,cs.y,cs.cx,cs.cy);
   }
   return ret;
  }
  case HCBT_DESTROYWND: {
   if (GetWindowStyle((HWND)wParam)&WS_CHILD) {
    ChildHook*ch=(ChildHook*)GetProp((HWND)wParam,MAKEINTATOM(gAtom));
    if (ch) {
     LocalFree(ch);
     RemoveProp((HWND)wParam,MAKEINTATOM(gAtom));
    }
   }
  }nobreak;
  default: return CallNextHookEx(ghhook,nCode,wParam,lParam);
 }
}

static int ltmove(UINT flags, int l, int w, int grow, int mouse) {
 switch (flags&3) {
  default: return 0;		// links/oben fixieren
  case 1: return -grow>>1;	// Fenster zentriert halten
  case 2: return -MulDiv(grow,clamp(mouse,l,l+w)-l,w);	// Mauspunkt fixieren
  case 3: return -grow;		// rechts/unten fixieren
 }
}

// Hier: RECT aus ltwh, nicht ltrb
static void GetWindowPos(HWND w,RECT*rw) {
 if (IsIconic(w)||IsZoomed(w)) {	// Kann das ein Kindfenster sein? Bei MDI: Ja!
  WINDOWPLACEMENT wp;
  wp.length=sizeof wp;
  GetWindowPlacement(w,&wp);		// Unklar was das fr Koordinaten sind!
  CopyRect(rw,&wp.rcNormalPosition);
  rw->right-=rw->left;
  rw->bottom-=rw->top;
 }else{
  GetWindowRect(w,rw);
  rw->right-=rw->left;
  rw->bottom-=rw->top;
  HWND p=GetAncestor(w,GA_PARENT);
  if (p) ScreenToClient(p,(POINT*)rw);
 }
}

// Hier: RECT aus ltwh, nicht ltrb
static HDWP SetWindowPos(HDWP dwp,HWND w,const RECT*rw,UINT flags=SWP_NOZORDER) {
 if (!dwp || IsIconic(w)||IsZoomed(w)) {
  WINDOWPLACEMENT wp;
  wp.length=sizeof wp;
  GetWindowPlacement(w,&wp);
  CopyRect(&wp.rcNormalPosition,rw);
  wp.rcNormalPosition.right+=wp.rcNormalPosition.left;
  wp.rcNormalPosition.bottom+=wp.rcNormalPosition.top;
  SetWindowPlacement(w,&wp);
  return dwp;
 }
#if 0
 return SetWindowPos(w,0,rw->left,rw->top,rw->right,rw->bottom,flags),dwp;
#else
 return DeferWindowPos(dwp,w,0,rw->left,rw->top,rw->right,rw->bottom,flags);
#endif
}

bool DlgHook::onSetFont(HWND hDlg,HFONT fnt,DWORD flags) {
 DBG(("SetFont(%X,%X,%X) this->font=%X",hDlg,fnt,flags,font));
 if (flags>>8 && !fnt) {
  fnt=font::CreateModifiedFont(font,flags>>8,MAKEWORD(-40,-8));
  if (!fnt) return false;
  if (!HIBYTE(flags>>8)		// FaceChange: Don't check for size change
  && LOBYTE(flags>>8)) {	// !SizeChange: Don't check for real size change
   SIZE ofs=font::MeasureFont(hDlg,font);
   for(;;) {
    SIZE fs=font::MeasureFont(hDlg,fnt);
    if (ofs.cx!=fs.cx || ofs.cy!=fs.cy) break;	// bei tatschlicher nderung raus!
    HFONT nfnt=font::CreateModifiedFont(fnt,flags>>8,MAKEWORD(-40,-10));
    DeleteFont(fnt);
    fnt=nfnt;
    if (!fnt) return false;
   }
  }
 }
 SIZE fs=font::MeasureFont(hDlg,fnt);
 if (font) {
  DBG(("Grennderung x:%d%d, y:%d%d",fs.cx,fs0.cx,fs.cy,fs0.cy));
  DeleteFont(font);
  RECT rw,rc;
  GetWindowPos(hDlg,&rw);
  GetClientRect(hDlg,&rc);
  rc.left=MulDiv(cs0.cx,fs.cx,fs0.cx);	// neue Clientgre in Pixel
  rc.top =MulDiv(cs0.cy,fs.cy,fs0.cy);
  DWORD mpos=GetMessagePos();
  int exx=rc.left-rc.right;
  rw.left+=ltmove(flags>>4,rw.left,rw.right,exx,GET_X_LPARAM(mpos));
  rw.right+=exx;
  int exy=rc.top-rc.bottom;
  rw.top +=ltmove(flags>>6,rw.top,rw.bottom,exy,GET_Y_LPARAM(mpos));
  rw.bottom+=exy;
  HDWP dwp=BeginDeferWindowPos(16);
  HWND w;
  for (w=GetFirstChild(hDlg); w; w=GetNextSibling(w)) {
   UINT swp_flags=SWP_NOZORDER;
   TCHAR classname[32];
   RealGetWindowClass(w,classname,elemof(classname));
   if (!lstrcmpi(classname,TEXT("Static")) && (GetWindowStyle(w)&SS_TYPEMASK)==SS_ICON) {
    DBG(("%s Icon bei Grennderung auslassen",classname));
    swp_flags|=SWP_NOSIZE;	// Positionieren ist ohne Problem mglich
   }				// Bei Grennderung hingegen verschwindet das Icon!
   ChildHook*ch=(ChildHook*)GetProp(w,MAKEINTATOM(gAtom));
   RECT rwc;
   ASSERT(ch);
   if (ch) CopyRect(&rwc,&ch->wr0);
   else{	// Kindfenster ohne Hook (darf gar nicht passieren!!)
    GetWindowPos(w,&rwc);
// Unrichtig fr:
// - Combobox mit CBS_DROPDOWN
// - Combobox mit CBS_SIMPLE und ohne CBS_NOINTEGRALHEIGHT
// - Listbox ohne LBS_NOINTEGRALHEIGHT
// - ComboBoxEx mit CBS_DROPDOWN
// Deshalb der CBT-Hook, der die anfngliche Grenfestlegung festhlt!
   }
   rwc.left  =MulDiv(rwc.left,  fs.cx,fs0.cx);
   rwc.top   =MulDiv(rwc.top,   fs.cy,fs0.cy);
   rwc.right =MulDiv(rwc.right, fs.cx,fs0.cx);
   rwc.bottom=MulDiv(rwc.bottom,fs.cy,fs0.cy);
   dwp=SetWindowPos(dwp,w,&rwc,swp_flags);
  }
  EndDeferWindowPos(dwp);
  SetWindowPos(0,hDlg,&rw);	// <== das via DeferWindowPos geht zur Hlle nicht!
// Danach ist besser als davor.
// Bei einer MessageBox im XP-Stil wird die Grauhinterlegung unten nicht mitplatziert.
// Scheint ein Teil von WM_PAINT zu sein!
  for (w=GetFirstChild(hDlg); w; w=GetNextSibling(w)) SetWindowFont(w,fnt,TRUE);
 }else{
  RECT rc;
  GetClientRect(hDlg,&rc);
  cs0=*(SIZE*)&rc.right;
  fs0=fs;
  DBG(("Erstmalige Gre: Client(%d,%d), Font(%d,%d)",
	cs0.cx,cs0.cy,fs0.cx,fs0.cy));
 }
 font=fnt;
 checkFontMenu();
 return true;
}

void DlgHook::checkFontMenu() {
 LOGFONT lf;
 GetObject(font,sizeof lf,&lf);
 BYTE ft=font::GetFontBits(0,font,lf);
 for (UINT id=0xF240;id<0xF280;id+=0x10,ft>>=1)
	CheckMenuItem(hmFont,id,ft&1?MF_CHECKED:MF_UNCHECKED);
}

UINT_PTR CALLBACK DlgHook::CFHookProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam) {
 switch (msg) {
  case WM_COMMAND: switch (LOWORD(wParam)) {
   case 0x402: {
    LOGFONT lf;
    SendMessage(hWnd,WM_CHOOSEFONT_GETLOGFONT,0,(LPARAM)&lf);
    SetWindowFont(GetParent(hWnd),CreateFontIndirect(&lf),TRUE);
   }break;
  }
 }
 return 0;
}

void DlgHook::chooseFont(HWND hWnd) {
 LOGFONT lf;
 GetObject(font?font:GetStockFont(SYSTEM_FONT),sizeof lf,&lf);
 CHOOSEFONT cf={
	sizeof cf,
	hWnd,
	0,	// dc
	&lf,
	0,	// pointsize
	CF_APPLY|CF_ENABLEHOOK|CF_FORCEFONTEXIST|CF_INITTOLOGFONTSTRUCT|CF_LIMITSIZE|CF_NOSCRIPTSEL|CF_NOVERTFONTS|CF_SCALABLEONLY,
	RGB(0,0,0),
	(INT_PTR)this,	// TODO: Alles richtig ausfllen
	CFHookProc,
	0,
	ghInstance,
	0,	// style
	0,	// nFontType
	0,	// alignment
	10,	// minpointsize
	40};	// maxpointsize
 if (ChooseFont(&cf)) SetWindowFont(hWnd,CreateFontIndirect(&lf),TRUE);	// Auch dieser Dialog wird gehookt!
}


// DLL API Function Hooking
FUNC(HWND) CreateDialog2W(HINSTANCE hInst,const WCHAR*t,HWND p,DLGPROC f) {
 Dialog2 d2={Dialog2::fromCreateDialog,0,0,t,hInst};
 return CreateDialogParam(hInst,t,p,f,(LPARAM)&d2);
}

FUNC(HWND) CreateDialog2Indirect(HINSTANCE hInst,const DLGTEMPLATE*t,HWND p,DLGPROC f) {
 Dialog2 d2={Dialog2::fromCreateDialogIndirectParam,0,t,0,hInst};
 return CreateDialogIndirectParam(hInst,t,p,f,(LPARAM)&d2);
}

FUNC(HWND) CreateDialog2IndirectParam(HINSTANCE hInst,const DLGTEMPLATE*t,HWND p,DLGPROC f,LPARAM lp) {
 Dialog2 d2={Dialog2::fromCreateDialogIndirectParam,lp,t,0,hInst};
 return CreateDialogIndirectParam(hInst,t,p,f,(LPARAM)&d2);
}

FUNC(BOOL) _DllMainCRTStartup(HINSTANCE hInst, ULONG rc, void*) {
 switch (rc) {
  case DLL_PROCESS_ATTACH:
  ++gNumProcess;
  DBG(("DLL_PROCESS_ATTACH, gNumProcess=%u",gNumProcess));
  if (!ghInstance) {
   ghInstance=hInst;
   gAtom=GlobalAddAtom(TEXT("dlgsize::DlgHook"));
   DisableThreadLibraryCalls(ghInstance=hInst);
   ghhook=SetWindowsHookEx(WH_CBT,CBTProc,ghInstance,0);
  }
//  ghhook=SetWindowsHookEx(WH_CBT,CBTProc,0,GetCurrentThreadId());
  break;
  case DLL_PROCESS_DETACH:
  if (!--gNumProcess && ghhook && UnhookWindowsHookEx(ghhook)) ghhook=0;
  GlobalDeleteAtom(gAtom);
  DBG(("DLL_PROCESS_DETACH, gNumProcess=%u",gNumProcess));
//  TODO: Alle SubclassWindow rckgngig!
  break;
 }
 return TRUE;
}

_declspec(dllexport) void CALLBACK run() {
 DBG(("Start"));
 MessageBox(0,TEXT("dlgsize.dll is running\nPress OK to exit run()"),TEXT("dlgsize.dll"),0);
}
